

#include<reg51.h>


sbit SO = P2^2; 		               //Input from TMP 125
sbit CS = P2^1;			   //Chip Select
sbit SCK = P2^0	;		   //Serial clock

char bdata ibase = 0xAA;				               
//Bit addressable register with the 8 bit A/D converted temperature
char bdata ibase2 = 0xAA; 				               
//Bit addressable register with the higher 3 bits and 3 flag bits

sbit mybit0 = ibase^0;  
sbit mybit1 = ibase^1;  
sbit mybit2 = ibase^2;  
sbit mybit3 = ibase^3;  
sbit mybit4 = ibase^4;  
sbit mybit5 = ibase^5;  
sbit mybit6 = ibase^6;
sbit mybit7 = ibase^7;
sbit mybit8 = ibase2^0;
sbit mybit9 = ibase2^1;
sbit mybit10 = ibase2^2;
sbit flag =	ibase2^3;
sbit temp = ibase2^4;
sbit disp =	ibase2^5;

unsigned char mybyte,mybyte2;			 			
//Variables used for serial interrupt
signed char o;							 		
//Variable for serial interrupt
unsigned char count,p,x,j;				 			
//Variables used for displaying message
unsigned char mul,tmpmul,degreec;		 				
//Variables used for displaying temperature

unsigned int i,k,m,n,l,g;				 		
//Miscellaneous variables used generally as counters for delays,scrolling and dispaying

unsigned char lbyte[2];					 			
//Array with temperature indexes
unsigned char index[34];				 				
//Array holding the index to the characters to be displayed 
unsigned char tmp[34];					 			
//Array holding the index to the characters to be displayed(Same as index)

const unsigned char code tempdisp[18]={					
//Array to display "'C"
0xFF,0XFF,0X1F,0X5F,0X5F,0X1F,0XFF,0XFF,
0XFF,0X81,0X81,0X7E,0X7E,0X7E,0X7E,0X7E,0X7E,0XFF,
};

const unsigned char code array[260]={					
//Array with patterns to display A-Z
0XFF,0X80,0X80,0X77,0X77,0X77,0X77,0X80,0X80,0XFF,		//A
0XFF,0X00,0X00,0X6E,0X6E,0X6E,0X6E,0X91,0X91,0XFF,		//B
0XFF,0X81,0X81,0X7E,0X7E,0X7E,0X7E,0X7E,0X7E,0XFF,		//C
0XFF,0X00,0X00,0X7E,0X7E,0X7E,0X7E,0X81,0X81,0XFF,		//D
0XFF,0X00,0X00,0X6E,0X6E,0X6E,0X6E,0X7E,0X7E,0XFF,		//E
0XFF,0X00,0X00,0X6F,0X6F,0X6F,0X6F,0X7F,0X7F,0XFF,		//F
0XFF,0XC3,0XBD,0X7E,0X7E,0X76,0X71,0XF7,0XF7,0XFF,		//G
0XFF,0X00,0X00,0XEF,0XEF,0XEF,0XEF,0X00,0X00,0XFF,		//H
0XFF,0X7E,0X7E,0X7E,0X00,0X00,0X7E,0X7E,0X7E,0XFF,		//I
0XFF,0X7E,0X7E,0X7E,0X01,0X03,0X7F,0X7F,0X7F,0XFF,		//J
0XFF,0X00,0X00,0XE7,0XDB,0XBD,0xBD,0X7E,0X7E,0XFF,		//K
0XFF,0X00,0X00,0XFC,0XFC,0XFC,0XFC,0XFC,0XFC,0XFF,		//L
0XFF,0X00,0X00,0XBF,0XDF,0XEF,0XBF,0X00,0X00,0XFF,		//M
0XFF,0X00,0X00,0XDF,0XEF,0XF7,0XFB,0X00,0X00,0XFF,		//N
0XFF,0X81,0X81,0X7E,0X7E,0X7E,0X7E,0X81,0X81,0XFF,		//O
0XFF,0X00,0X00,0X77,0X77,0X77,0X77,0X77,0X8F,0XFF,		//P
0XFF,0XC3,0XBD,0X7E,0X7E,0X76,0X7A,0XBD,0XC2,0XFF,		//Q
0XFF,0X00,0x00,0X77,0X73,0X75,0x76,0X8E,0x8E,0XFF,		//R
0XFF,0X8E,0X8E,0X6E,0X6E,0X6E,0X6E,0XF1,0XF1,0XFF,		//S
0XFF,0X7F,0X7F,0x7F,0X00,0X00,0X7F,0X7F,0X7F,0XFF,		//T
0XFF,0X01,0X01,0XFE,0XFE,0XFE,0XFE,0X01,0X01,0XFF,		//U
0XFF,0X0F,0XF7,0XF9,0XFE,0XFE,0XF9,0XF7,0X0F,0XFF,		//V
0XFF,0X0F,0XF0,0XFC,0XF3,0XF3,0XFC,0XF0,0X0F,0XFF,		//W
0XFF,0X7E,0XBD,0XDB,0XE7,0XE7,0XDB,0XBD,0X7E,0XFF,		//X
0XFF,0X7F,0XBF,0XDF,0XE0,0XE0,0XDF,0XBF,0X7F,0XFF,		//Y
0XFF,0X7E,0X7C,0X7A,0X76,0X6E,0X5E,0X3E,0X7E,0XFF		//Z
};

const unsigned char code array2[110]={					
//Array wit patterns to display 0-9 and spacebar
0XFF,0X00,0X00,0X3E,0X3E,0X3E,0X3E,0X00,0X00,0XFF, 		//0
0XFF,0XDE,0XBE,0X7E,0X7E,0X00,0X00,0XFE,0XFE,0XFF,		//1	
0XFF,0X60,0X60,0X6E,0X6E,0X6E,0X6E,0X0E,0X0E,0XFF,		//2
0XFF,0X7E,0X7E,0X6E,0X6E,0X6E,0X6E,0X00,0X00,0XFF,		//3
0XFF,0X07,0X07,0XF7,0XF7,0XF7,0XF7,0X00,0X00,0XFF, 		//4
0XFF,0X60,0X60,0X6E,0X6E,0X6E,0X6E,0X0E,0X0E,0XFF,		//2	
//0XFF,0X0E,0X0E,0X6E,0X6E,0X6E,0X6E,0X60,0X60,0XFF, 		//5
0XFF,0X00,0X00,0X6E,0X6E,0X6E,0X6E,0X70,0X70,0XFF, 		//6
0XFF,0X3F,0X7C,0X78,0X73,0X67,0X6F,0X1F,0X1F,0XFF, 		//7
0XFF,0X00,0X00,0X66,0X66,0X66,0X66,0X00,0X00,0XFF, 		//8
0XFF,0X0E,0X0E,0X6E,0X6E,0X6E,0X6E,0X00,0X00,0XFF,		//9
0XFF,0XFF,0XFF,0XFF,0XFF,0XFF,0XFF,0XFF,0XFF,0XFF, 		//space
};	

const unsigned char code point[80]={					
//Array with patters to display "00,25,50,75"
0XFF,0X00,0X00,0X3E,0X3E,0X3E,0X3E,0X00,0X00,0XFF, 		//00
0XFF,0X00,0X00,0X3E,0X3E,0X3E,0X3E,0X00,0X00,0XFF, 		//
0XFF,0X60,0X60,0X6E,0X6E,0X6E,0X6E,0X0E,0X0E,0XFF,		//25
0XFF,0X0E,0X0E,0X6E,0X6E,0X6E,0X6E,0X60,0X60,0XFF, 		//
0XFF,0X0E,0X0E,0X6E,0X6E,0X6E,0X6E,0X60,0X60,0XFF, 		//50
0XFF,0X00,0X00,0X3E,0X3E,0X3E,0X3E,0X00,0X00,0XFF, 		//
0XFF,0X3F,0X7C,0X78,0X73,0X67,0X6F,0X1F,0X1F,0XFF, 		//75
0XFF,0X0E,0X0E,0X6E,0X6E,0X6E,0X6E,0X60,0X60,0XFF, 		//
} ;

const unsigned char code compare[38]={					
//Array with ASCII codes of A-Z,0-9,spacebar and CR
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,
0x4B,0x4C,0x4D,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,
0x55,0x56,0x57,0x58,0x59,0x5A,0x30,0x31,0x32,0x33,
0x34,0x35,0x36,0x37,0x38,0x39,0x20,0x0D
};

const unsigned char code stop=0xFF;						
//To display nothing

unsigned int hextobcd(unsigned int databyte)			
//Function to change hexadecimal number into BCD
{
	unsigned int temp=0;
	while(databyte > 9)
	{
		databyte-=10;
		temp+=0x10;
	}
	return(temp | databyte);
}


void delay(void)								
//Function for 500ms delay
{
	
	for (m=0;m<500;m++)
		for (n=0;n<1275;n++);

}
 

void tdelay(void)								
//Function for 10ms delay
{
	for (m=0;m<10;m++)
		for (n=0;n<1275;n++);
	
}


void tempcalc()								
//Function to setup SPI bus and get the 8 bit A/D converted temp 
//Also it calls hextoBCD to convert the temperature to BCD
{
	unsigned int initialtemp;
	
	SO=1;
	SCK=1;
	tdelay();
	CS=1;
	tdelay();
	CS=0;
		
		SCK=~SCK ;
		mybit10=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit9=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit8=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit7=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit6=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit5=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit4=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit3=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit2=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit1=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
			
		SCK=~SCK ;
		mybit0=SO;
		tdelay();
		SCK=~SCK ;
		tdelay();
		
		CS=1;
		initialtemp=(128*mybit7);
		mul=(64*mybit6);
		initialtemp+=mul;
		mul=(32*mybit5);
		initialtemp+=mul;
		mul=(16*mybit4);
		initialtemp+=mul;
		mul=(8*mybit3);
		initialtemp+=mul;
		mul=(4*mybit2);
		initialtemp+=mul;
		mul=(2*mybit1);
		initialtemp+=mul;
		mul=(1*mybit0);
		initialtemp+=mul;
		initialtemp=initialtemp-20;
		initialtemp=initialtemp/4;
		mul=initialtemp%4;
		initialtemp=hextobcd(initialtemp);
		
		if (mul==0)
			mul=0;
		else if (mul==1)
			mul=20;
		else if (mul==2)
			mul=40;
		else if (mul==3)
			mul=60;
		
		lbyte[0]=initialtemp&0x0F;
		lbyte[1]=initialtemp>>4;
}


void serial_int (void) interrupt 4	using 0	   
//Function is interrupt service routine for Serial Interrupt			
//Basically stores to indexes of the characters entered by 
//comparing against the the ASCII codes array
{
	//mybyte2 = SBUF;
	//mybyte=mybyte2&0x7F;
	//if ( mybyte ==0x10)
	//{
		ES=0;
		EA=0;
		//RI = 0;
		//while(RI == 0);
		mybyte=SBUF;
	RI=0;
	//	mybyte=mybyte2&0x7F;
		for(j=0;j<38;j++)
		{
			if (mybyte==compare[j])
			{
				if (mybyte==0x0D)
				{
					flag=1;
					P1=0x00;
					delay();
				//	o++;
				}
				else
				{
					o++;
					index[o]=j;
					tmp[o]=index[o];
					P1=mybyte;
					delay();
				}	
			}
		}
		ES=1;
		EA=1;
	//}
	RI=0;    
}



void introutine(void) interrupt 0 using 2		 
//Function is interrupt service routine for External interrupt 0
//It is bascially a position decoder and starts the timer interrupt
//alongwith switching between displaying message and temperature
{
	TF0=0;
EX0=0;   
	TH0=0xAF;
	i=0;
	p=0;
	m=0;
	count=0;
	x=tmp[0];
	m=x*10;
	n=(x-26)*10;
	g++;
	temp=1;
	if (g==1700)
	{
		tempcalc();
		temp=0;
	}
	if (g >1700 & g<3400)
	{
		mybyte=lbyte[0]*10;
		mybyte2=lbyte[1]*10;
		tmpmul=mul;
		degreec=0;
		temp=0;
		disp=1;
	}
	if(g==3400)
	{
		g=0;
		disp=0;
		temp=1;
	}
	
	TR0=1;
	j++;
	if(j==5)
	{
		j=0;
		k++;
	} 
	if (k>340)
	{
		k=0;
	}
	l=k;
}


void timer0(void) interrupt 1  using 3		  
//Function is interrupt service routine for timer 0 (Auto reload mode)		
//It basically displays the characters or the temperature depending on flag bits	
//along with displaying blanks in front of data for scrolling
{
	if (disp==1)
	{
		if(l!=0)
		{
			P1=0xFF;
			l--;
		}
		if(l==0)
		{
			if(i<63)
			{
				if ((i<10))
				{
					 P1= array2[mybyte2];
					 mybyte2++;
					 i++;
				}
				if ((i>=10) & (i<20))
				{
					P1= array2[mybyte];
					mybyte++;
					i++;
				}
				if ((i>=20)&(i<22))
				{
					P1=0xFF;
					i++; 
				}
				if (i==22)
				{
					P1=0xFE;
					i++; 
				}
				if ((i>22)&(i<25))
				{
					P1=0xFF;
					i++; 
				}
				if((i>=25)&(i<45))
				{
					 P1=point[tmpmul];
					 tmpmul++;
					 i++;
				}
				if (i>=45)
				{
					P1=tempdisp[degreec];
					degreec++;
					i++;
				}
			}
			else
				P1=stop;
		}
	}
	if (temp==1)
	{
		if(l!=0)
		{
			P1=0xFF;
			l--;
		}
		if(l==0)
		{
			if(i<(o*10))
			{
				if  (m<260)
				{
					P1=array[m];
					m++;
					i++;
					count++;
					if (count==10)
					{
						count=0;
						p++;
						x=tmp[p];
						m=x*10;
						n=(x-26)*10	;
					}
				}
				else if ( m>=260 & m<370)
				{
					P1=array2[n];
					n++;	 
					i++;
					count++;
					if (count==10)
					{
						count=0;
						p++;
						x=tmp[p];
						m=x*10;
						n=(x-26)*10;
					}
				}
			}
			else
				P1=stop ; 
		}
	}
	else
		P1=stop;
	EX0=1;
	TF0=0;
}



void main(void)				//Execution starts here
{
       flag=0;
       o=-1;
       SCON = 0x50;         		/* mode 1, 8-bit uart, enable receiver */
       TMOD = 0x20;         		/* timer 1, mode 2, 8-bit reload */
       TH1  = 0xFD;         		/* reload value for 1200 baud */
       ET0  = 0;            			/* we don't want this timer to make interrupts */
       TR1  = 1;            			/* start the timer */
       TI   = 1;            /* clear the buffer */
       ES   = 1;            /* allow serial interrupts */
       EA   = 1;            /* enable interrupts */
       while (1)
	   {
	   		if (flag==1)	// Enters once CR is pressed
			{
				EA=0;
				ES=0;
				disp=0;
				TR1=0;
				P1=0xFF;
				delay();
				j=0;
				k=0;
				m=0;
				g=0;
				TMOD=0x12;
				TH0=0xAF;
				temp=0;
				EX0   = 1;                    
				IT0   = 1;                     
				ET0   = 1;                  
				PT0   = 1;                      
				PX0   = 1;                      
				P1=0xFF;
				P3=0xFF;		
				flag=0;
				EA = 1;   
			}
			P1=0xFF;
	   }          

}





